MeSoHordieAddon.aceGui = LibStub("AceGUI-3.0")

MeSoHordieAddon.offer = {}
MeSoHordieAddon.offer.open = false
MeSoHordieAddon.offer.state = {}

local itemSlotTable = {
    ["INVTYPE_AMMO"] = 0,
    ["INVTYPE_HEAD"] = 1,
    ["INVTYPE_NECK"] = 2,
    ["INVTYPE_SHOULDER"] = 3,
    ["INVTYPE_BODY"] = 4,
    ["INVTYPE_CHEST"] = 5,
    ["INVTYPE_ROBE"] = 5,
    ["INVTYPE_WAIST"] = 6,
    ["INVTYPE_LEGS"] = 7,
    ["INVTYPE_FEET"] = 8,
    ["INVTYPE_WRIST"] = 9,
    ["INVTYPE_HAND"] = 10,
    ["INVTYPE_FINGER"] = 11,
    ["INVTYPE_TRINKET"] = 13,
    ["INVTYPE_CLOAK"] = 15,
    ["INVTYPE_WEAPON"] = 16,
    ["INVTYPE_SHIELD"] = 17,
    ["INVTYPE_2HWEAPON"] = 16,
    ["INVTYPE_WEAPONMAINHAND"] = 16,
    ["INVTYPE_WEAPONOFFHAND"] = 17,
    ["INVTYPE_HOLDABLE"] = 17,
    ["INVTYPE_RANGED"] = 18,
    ["INVTYPE_THROWN"] = 18,
    ["INVTYPE_RANGEDRIGHT"] = 18,
    ["INVTYPE_RELIC"] = 18,
    ["INVTYPE_TABARD"] = 19
};

function MeSoHordieAddon:usableSlotID(itemEquipLoc)
    return itemSlotTable[itemEquipLoc] or nil
end

function MeSoHordieAddon:CloseOfferWindow()
    if self.offer.open then
        self.offer.rootFrame:Hide()
        self.offer.rootFrame = nil
        self.offer.open = false
    end
end

function MeSoHordieAddon:ShowOfferWindowFor(itemId, author)
    self:CloseOfferWindow()

    if self:CharacterHasItem(itemId) then
        return
    end

    if not MSHB:itemIsBestInSlotForMe(itemId) then
        return
    end

    if not MSHB:target_player_is_master_looter(author) then
        return
    end
    self.offer.open = true

    local frame = self.aceGui:Create("Window")
    self.offer.rootFrame = frame
    frame:EnableResize(false)
    frame:SetWidth(320)
    frame:SetHeight(110)
    frame:SetTitle("BiS reminder")

    frame.frame:EnableKeyboard(true)
    frame.frame:SetScript("OnKeyDown", function(self, key)
        if key == "ESCAPE" then
            frame.frame:SetPropagateKeyboardInput(false)
            MeSoHordieAddon:CloseOfferWindow()
        else
            frame.frame:SetPropagateKeyboardInput(true)
        end

        if key == "LSHIFT" then
            MeSoHordieAddon.gui.state.shiftHeld = true
            frame.frame:SetPropagateKeyboardInput(false)
            MeSoHordieAddon:InvalidateTooltip()
        end
    end)

    frame.frame:SetScript("OnKeyUp", function(self, key)
        if key == "LSHIFT" then
            MeSoHordieAddon.gui.state.shiftHeld = false
            MeSoHordieAddon:InvalidateTooltip()
        end
    end)

    itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice =
        GetItemInfo(itemId)
    print(itemEquipLoc)
    self:AddItemWidget(frame, tostring(itemId), false, self:usableSlotID(itemEquipLoc))

    local buttonGroup = self.aceGui:Create("SimpleGroup")
    frame:AddChild(buttonGroup)
    buttonGroup:SetLayout("Flow")

    local acceptButton = self.aceGui:Create("Button")
    acceptButton:SetText("BiS")
    buttonGroup:AddChild(acceptButton)
    acceptButton:SetRelativeWidth(0.5)

    local passButton = self.aceGui:Create("Button")
    passButton:SetText("Pass")
    buttonGroup:AddChild(passButton)
    passButton:SetRelativeWidth(0.5)

    acceptButton:SetCallback("OnClick", function(widget, event, button)
        SendChatMessage("BiS", "RAID");
        self:CloseOfferWindow()
    end)

    passButton:SetCallback("OnClick", function(widget, event, button)
        self:CloseOfferWindow()
    end)
end
